Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/WeaponSystem.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/WeaponSystem.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/WeaponSystem.h	(revision 2907)
@@ -53,5 +53,4 @@
             //void fire();
             void fire(WeaponMode::Enum fireMode);
-            //void setActiveWeaponSet(unsigned int n);
             void attachWeaponPack(WeaponPack * wPack, unsigned int firemode);
             WeaponSet * getWeaponSetPointer(unsigned int n);
@@ -59,4 +58,5 @@
             WeaponPack * getWeaponPackPointer(unsigned int n);
             void setNewMunition(std::string munitionType, Munition * munitionToAdd);
+            void setNewSharedMunition(std::string munitionType, Munition * munitionToAdd);
             Munition * getMunitionType(std::string munitionType);
 
@@ -74,5 +74,4 @@
             std::vector<WeaponPack *> weaponPacks_;
             std::map<std::string, Munition *> munitionSet_;
-            WeaponSet *activeWeaponSet_;
             Pawn *parentPawn_;
     };
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt	(revision 2907)
@@ -1,3 +1,4 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
   LaserGunMunition.cc
+  FusionMunition.cc
 )
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/FusionMunition.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/FusionMunition.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/FusionMunition.cc	(revision 2907)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Polak
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "util/Debug.h"
+
+#include "FusionMunition.h"
+
+namespace orxonox
+{
+    CreateFactory(FusionMunition);
+
+    FusionMunition::FusionMunition(BaseObject* creator) : Munition(creator)
+    {
+        RegisterObject(FusionMunition);
+
+        //default if not defined in XML
+        this->maxBullets_ = 10;
+        this->maxMagazines_ = 100;
+    }
+
+    FusionMunition::~FusionMunition()
+    {
+    }
+
+    void FusionMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+
+    }
+
+}
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/FusionMunition.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/FusionMunition.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/FusionMunition.h	(revision 2907)
@@ -0,0 +1,54 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Polak
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _FusionMunition_H__
+#define _FusionMunition_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "core/BaseObject.h"
+#include "../Munition.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport FusionMunition : public Munition
+    {
+        public:
+            FusionMunition(BaseObject* creator);
+            virtual ~FusionMunition();
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+
+        private:
+
+
+    };
+}
+
+#endif /* _FusionMunition_H__ */
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc	(revision 2907)
@@ -43,4 +43,5 @@
         RegisterObject(LaserGunMunition);
 
+        //default if not defined in XML
         this->maxBullets_ = 40;
         this->maxMagazines_ = 100;
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/BillboardProjectile.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/BillboardProjectile.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/BillboardProjectile.cc	(revision 2907)
@@ -32,5 +32,5 @@
 #include <OgreBillboardSet.h>
 
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "objects/Scene.h"
@@ -44,5 +44,5 @@
         RegisterObject(BillboardProjectile);
 
-        if (Core::showsGraphics())
+        if (GameMode::showsGraphics())
         {
             assert(this->getScene()->getSceneManager()); // getScene() was already checked by WorldEntity
@@ -56,5 +56,5 @@
     BillboardProjectile::~BillboardProjectile()
     {
-        if (this->isInitialized() && Core::showsGraphics() && this->billboard_.getBillboardSet())
+        if (this->isInitialized() && GameMode::showsGraphics() && this->billboard_.getBillboardSet())
             this->detachOgreObject(this->billboard_.getBillboardSet());
     }
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/ParticleProjectile.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/ParticleProjectile.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/ParticleProjectile.cc	(revision 2907)
@@ -33,5 +33,5 @@
 #include <OgreParticleEmitter.h>
 
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
@@ -46,5 +46,5 @@
         RegisterObject(ParticleProjectile);
 
-        if (Core::showsGraphics())
+        if (GameMode::showsGraphics())
         {
             this->particles_ = new ParticleInterface(this->getScene()->getSceneManager(), "Orxonox/shot3_small", LODParticle::normal);
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/Projectile.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/Projectile.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/projectiles/Projectile.cc	(revision 2907)
@@ -41,5 +41,5 @@
 #include "objects/worldentities/ParticleSpawner.h"
 #include "objects/collisionshapes/SphereCollisionShape.h"
-#include "core/Core.h"
+#include "core/GameMode.h"
 
 namespace orxonox
@@ -55,5 +55,5 @@
         // Get notification about collisions
 
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             this->enableCollisionCallback();
@@ -93,5 +93,5 @@
     void Projectile::destroyObject()
     {
-        if (Core::isMaster())
+        if (GameMode::isMaster())
             delete this;
     }
@@ -99,5 +99,5 @@
     bool Projectile::collidesAgainst(WorldEntity* otherObject, btManifoldPoint& contactPoint)
     {
-        if (!this->bDestroy_ && Core::isMaster())
+        if (!this->bDestroy_ && GameMode::isMaster())
         {
             this->bDestroy_ = true;
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/weapons/LaserGun.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/weapons/LaserGun.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/weapons/LaserGun.cc	(revision 2907)
@@ -53,9 +53,17 @@
     }
 
+    void LaserGun::reloadBullet()
+    {
+        this->bulletTimer(this->bulletLoadingTime_);
+    }
+
+    void LaserGun::reloadMagazine()
+    {
+        this->magazineTimer(this->magazineLoadingTime_);
+    }
+
     void LaserGun::takeBullets()
     {
-//COUT(0) << "LaserGun::takeBullets" << std::endl;
         this->munition_->removeBullets(1);
-        this->bulletTimer(this->bulletLoadingTime_);
     }
 
@@ -63,10 +71,8 @@
     {
         this->munition_->removeMagazines(1);
-        this->magazineTimer(this->magazineLoadingTime_);
     }
 
     void LaserGun::createProjectile()
     {
-//COUT(0) << "LaserGun::createProjectile" << std::endl;
         BillboardProjectile* projectile = new ParticleProjectile(this);
         projectile->setOrientation(this->getWorldOrientation());
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/weapons/LaserGun.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/weapons/LaserGun.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/weapons/LaserGun.h	(revision 2907)
@@ -51,4 +51,6 @@
             virtual void takeMagazines();
             virtual void createProjectile();
+            virtual void reloadBullet();
+            virtual void reloadMagazine();
 
         private:
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Backlight.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Backlight.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Backlight.cc	(revision 2907)
@@ -33,5 +33,5 @@
 #include <OgreSceneManager.h>
 
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/Executor.h"
@@ -58,5 +58,5 @@
         this->tickcount_ = 0;
 
-        if (Core::showsGraphics())
+        if (GameMode::showsGraphics())
         {
             if (!this->getScene())
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Backlight.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Backlight.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Backlight.h	(revision 2907)
@@ -32,5 +32,5 @@
 #include "OrxonoxPrereqs.h"
 #include "FadingBillboard.h"
-#include "gamestates/GSRoot.h"
+#include "tools/TimeFactorListener.h"
 
 namespace orxonox
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Billboard.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Billboard.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Billboard.cc	(revision 2907)
@@ -34,5 +34,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "objects/Scene.h"
 
@@ -81,5 +81,5 @@
         if (!this->billboard_.getBillboardSet())
         {
-            if (this->getScene() && Core::showsGraphics())
+            if (this->getScene() && GameMode::showsGraphics())
             {
                 this->billboard_.setBillboardSet(this->getScene()->getSceneManager(), this->material_, this->colour_, 1);
@@ -98,5 +98,5 @@
         {
 /*
-            if (this->getScene() && Core::showsGraphics() && (this->material_ != ""))
+            if (this->getScene() && GameMode::showsGraphics() && (this->material_ != ""))
             {
                 this->billboard_.setBillboardSet(this->getScene()->getSceneManager(), this->material_, this->colour_, 1);
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Billboard.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Billboard.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Billboard.h	(revision 2907)
@@ -34,8 +34,9 @@
 #include "util/Math.h"
 #include "tools/BillboardSet.h"
+#include "objects/Teamcolourable.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport Billboard : public StaticEntity
+    class _OrxonoxExport Billboard : public StaticEntity, public Teamcolourable
     {
         public:
@@ -61,4 +62,7 @@
                 { return this->colour_; }
 
+            virtual void setTeamColour(const ColourValue& colour)
+                { this->setColour(colour); }
+
         protected:
             inline BillboardSet& getBillboardSet()
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/BlinkingBillboard.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/BlinkingBillboard.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/BlinkingBillboard.cc	(revision 2907)
@@ -30,5 +30,5 @@
 #include "BlinkingBillboard.h"
 
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -77,5 +77,5 @@
         SUPER(BlinkingBillboard, tick, dt);
 
-        if (Core::isMaster() && this->isActive())
+        if (GameMode::isMaster() && this->isActive())
         {
             this->time_ += dt;
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/CMakeLists.txt	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/CMakeLists.txt	(revision 2907)
@@ -19,4 +19,8 @@
   Planet.cc
   SpawnPoint.cc
+  TeamSpawnPoint.cc
+  PongCenterpoint.cc
+  PongBall.cc
+  PongBat.cc
 )
 
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/CameraPosition.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/CameraPosition.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/CameraPosition.cc	(revision 2907)
@@ -44,4 +44,5 @@
         this->bDrag_ = false;
         this->bAllowMouseLook_ = false;
+        this->bAbsolute_ = false;
 
         this->setObjectMode(0x0);
@@ -58,4 +59,5 @@
         XMLPortParam(CameraPosition, "drag", setDrag, getDrag, xmlelement, mode).defaultValues(false);
         XMLPortParam(CameraPosition, "mouselook", setAllowMouseLook, getAllowMouseLook, xmlelement, mode).defaultValues(false);
+        XMLPortParam(CameraPosition, "absolute", setIsAbsolute, getIsAbsolute, xmlelement, mode).defaultValues(false);
     }
 
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/CameraPosition.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/CameraPosition.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/CameraPosition.h	(revision 2907)
@@ -54,4 +54,9 @@
                 { return this->bAllowMouseLook_; }
 
+            inline void setIsAbsolute(bool bAbsolute)
+                { this->bAbsolute_ = bAbsolute; }
+            inline bool getIsAbsolute() const
+                { return this->bAbsolute_; }
+
             void attachCamera(Camera* camera);
 
@@ -59,4 +64,5 @@
             bool bDrag_;
             bool bAllowMouseLook_;
+            bool bAbsolute_;
     };
 }
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/ControllableEntity.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 2907)
@@ -34,5 +34,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/XMLPort.h"
 #include "core/Template.h"
@@ -144,8 +144,17 @@
     void ControllableEntity::addCameraPosition(CameraPosition* position)
     {
-        if (position->getAllowMouseLook())
-            position->attachToNode(this->cameraPositionRootNode_);
+        if (!position->getIsAbsolute())
+        {
+            if (position->getAllowMouseLook())
+                position->attachToNode(this->cameraPositionRootNode_);
+            else
+                this->attach(position);
+        }
         else
-            this->attach(position);
+        {
+            WorldEntity* parent = this->getParent();
+            if (parent)
+                parent->attach(position);
+        }
         this->cameraPositions_.push_back(position);
     }
@@ -236,5 +245,5 @@
             this->startLocalHumanControl();
 
-            if (!Core::isMaster())
+            if (!GameMode::isMaster())
             {
                 this->client_overwrite_ = this->server_overwrite_;
@@ -242,4 +251,6 @@
             }
         }
+
+        this->changedPlayer();
     }
 
@@ -254,4 +265,6 @@
         this->bHasHumanController_ = false;
         this->setObjectMode(objectDirection::toclient);
+
+        this->changedPlayer();
 
         if (this->bDestroyWhenPlayerLeft_)
@@ -322,4 +335,17 @@
     }
 
+    void ControllableEntity::parentChanged()
+    {
+        WorldEntity::parentChanged();
+
+        WorldEntity* parent = this->getParent();
+        if (parent)
+        {
+            for (std::list<CameraPosition*>::iterator it = this->cameraPositions_.begin(); it != this->cameraPositions_.end(); ++it)
+                if ((*it)->getIsAbsolute())
+                    parent->attach((*it));
+        }
+    }
+
     void ControllableEntity::tick(float dt)
     {
@@ -331,5 +357,5 @@
             if (!this->isDynamic())
             {
-                if (Core::isMaster())
+                if (GameMode::isMaster())
                 {
                     this->server_position_ = this->getPosition();
@@ -446,5 +472,5 @@
     void ControllableEntity::setPosition(const Vector3& position)
     {
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             MobileEntity::setPosition(position);
@@ -461,5 +487,5 @@
     void ControllableEntity::setOrientation(const Quaternion& orientation)
     {
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             MobileEntity::setOrientation(orientation);
@@ -476,5 +502,5 @@
     void ControllableEntity::setVelocity(const Vector3& velocity)
     {
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             MobileEntity::setVelocity(velocity);
@@ -491,5 +517,5 @@
     void ControllableEntity::setAngularVelocity(const Vector3& velocity)
     {
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             MobileEntity::setAngularVelocity(velocity);
@@ -507,5 +533,5 @@
     {
         MobileEntity::setWorldTransform(worldTrans);
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             this->server_position_ = this->getPosition();
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/ControllableEntity.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/ControllableEntity.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/ControllableEntity.h	(revision 2907)
@@ -49,4 +49,5 @@
 
             virtual void changedGametype();
+            virtual void changedPlayer() {}
 
             virtual void setPlayer(PlayerInfo* player);
@@ -136,4 +137,5 @@
             virtual void startLocalHumanControl();
             virtual void stopLocalHumanControl();
+            virtual void parentChanged();
 
             inline void setHudTemplate(const std::string& name)
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/ExplosionChunk.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/ExplosionChunk.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/ExplosionChunk.cc	(revision 2907)
@@ -32,5 +32,5 @@
 #include <OgreParticleSystem.h>
 
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/Executor.h"
@@ -47,5 +47,5 @@
         RegisterObject(ExplosionChunk);
 
-        if ( Core::showsGraphics() && ( !this->getScene() || !this->getScene()->getSceneManager() ) )
+        if ( GameMode::showsGraphics() && ( !this->getScene() || !this->getScene()->getSceneManager() ) )
             ThrowException(AbortLoading, "Can't create ExplosionChunk, no scene or no scene manager given.");
 
@@ -53,5 +53,5 @@
         this->LOD_ = LODParticle::normal;
 
-        if ( Core::showsGraphics() )
+        if ( GameMode::showsGraphics() )
         {
             try
@@ -75,5 +75,5 @@
         }
 
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             Vector3 velocity(rnd(-1, 1), rnd(-1, 1), rnd(-1, 1));
@@ -132,5 +132,5 @@
             this->smoke_->setEnabled(false);
 
-        if (Core::isMaster())
+        if (GameMode::isMaster())
         {
             this->bStop_ = true;
@@ -148,5 +148,5 @@
         static const unsigned int CHANGES_PER_SECOND = 5;
 
-        if (Core::isMaster() && rnd() < dt*CHANGES_PER_SECOND)
+        if (GameMode::isMaster() && rnd() < dt*CHANGES_PER_SECOND)
         {
             float length = this->getVelocity().length();
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Light.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Light.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Light.cc	(revision 2907)
@@ -37,5 +37,5 @@
 #include "util/String.h"
 #include "util/Exception.h"
-#include "core/Core.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -57,5 +57,5 @@
         this->spotlightRange_ = Vector3(40.0f, 30.0f, 1.0f);
 
-        if (Core::showsGraphics())
+        if (GameMode::showsGraphics())
         {
             if (!this->getScene())
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Light.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Light.h	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Light.h	(revision 2907)
@@ -37,8 +37,9 @@
 
 #include "util/Math.h"
+#include "objects/Teamcolourable.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport Light : public StaticEntity
+    class _OrxonoxExport Light : public StaticEntity, public Teamcolourable
     {
         public:
@@ -68,4 +69,7 @@
             inline const ColourValue& getSpecularColour() const
                 { return this->specular_; }
+
+            virtual void setTeamColour(const ColourValue& colour)
+                { this->setDiffuseColour(colour); this->setSpecularColour(colour); }
 
             /**
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/MobileEntity.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/MobileEntity.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/MobileEntity.cc	(revision 2907)
@@ -182,5 +182,6 @@
         // We use a dynamic body. So we translate our node accordingly.
         this->node_->setPosition(Vector3(worldTrans.getOrigin().x(), worldTrans.getOrigin().y(), worldTrans.getOrigin().z()));
-        this->node_->setOrientation(Quaternion(worldTrans.getRotation().w(), worldTrans.getRotation().x(), worldTrans.getRotation().y(), worldTrans.getRotation().z()));
+        btQuaternion temp(worldTrans.getRotation());
+        this->node_->setOrientation(Quaternion(temp.w(), temp.x(), temp.y(), temp.z()));
         this->linearVelocity_.x = this->physicalBody_->getLinearVelocity().x();
         this->linearVelocity_.y = this->physicalBody_->getLinearVelocity().y();
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Model.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Model.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Model.cc	(revision 2907)
@@ -31,4 +31,5 @@
 #include <OgreEntity.h>
 #include "Model.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -70,5 +71,5 @@
     void Model::changedMesh()
     {
-        if (Core::showsGraphics())
+        if (GameMode::showsGraphics())
         {
             if (this->mesh_.getEntity())
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/MovableEntity.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2907)
@@ -34,5 +34,5 @@
 #include "core/XMLPort.h"
 #include "core/Executor.h"
-#include "core/Core.h"
+#include "core/GameMode.h"
 
 namespace orxonox
@@ -89,5 +89,5 @@
     void MovableEntity::resynchronize()
     {
-        if (Core::isMaster() && !this->continuousResynchroTimer_)
+        if (GameMode::isMaster() && !this->continuousResynchroTimer_)
         {
             // Resynchronise every few seconds because we only work with velocities (no positions)
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/ParticleEmitter.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/ParticleEmitter.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/ParticleEmitter.cc	(revision 2907)
@@ -39,4 +39,5 @@
 #include "tools/ParticleInterface.h"
 #include "util/Exception.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -51,5 +52,5 @@
         RegisterObject(ParticleEmitter);
 
-        if (Core::showsGraphics() && (!this->getScene() || !this->getScene()->getSceneManager()))
+        if (GameMode::showsGraphics() && (!this->getScene() || !this->getScene()->getSceneManager()))
             ThrowException(AbortLoading, "Can't create ParticleEmitter, no scene or no scene manager given.");
 
@@ -107,5 +108,5 @@
         }
 
-        if (Core::showsGraphics() && this->getScene() && this->getScene()->getSceneManager())
+        if (GameMode::showsGraphics() && this->getScene() && this->getScene()->getSceneManager())
         {
             try
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Planet.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Planet.cc	(revision 2788)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Planet.cc	(revision 2907)
@@ -42,5 +42,5 @@
 #include "CameraManager.h"
 #include "Camera.h"
-#include "GraphicsEngine.h"
+#include "GraphicsManager.h"
 
 namespace orxonox
